"""Constants for the Hoymiles WiFi integration."""

DTU_PORT = 10081

# App -> DTU start with 0xa3, responses start 0xa2
CMD_HEADER = b"HM"
CMD_APP_INFO_DATA_RES_DTO = b"\xa3\x01"
CMD_HB_RES_DTO = b"\xa3\x02"
CMD_REAL_DATA_RES_DTO = b"\xa3\x03"
CMD_W_INFO_RES_DTO = b"\xa3\x04"
CMD_COMMAND_RES_DTO = b"\xa3\x05"
CMD_COMMAND_STATUS_RES_DTO = b"\xa3\x06"
CMD_DEV_CONFIG_FETCH_RES_DTO = b"\xa3\x07"
CMD_DEV_CONFIG_PUT_RES_DTO = b"\xa3\x08"
CMD_GET_CONFIG = b"\xa3\x09"
CMD_SET_CONFIG = b"\xa3\x10"
CMD_REAL_RES_DTO = b"\xa3\x11"
CMD_GPST_RES_DTO = b"\xa3\x12"
CMD_AUTO_SEARCH = b"\xa3\x13"
CMD_NETWORK_INFO_RES = b"\xa3\x14"
CMD_APP_GET_HIST_POWER_RES = b"\xa3\x15"
CMD_APP_GET_HIST_ED_RES = b"\xa3\x16"
CMD_HB_RES_DTO_ALT = b"\x83\x01"
CMD_REGISTER_RES_DTO = b"\x83\x02"
CMD_STORAGE_DATA_RES = b"\x83\x03"
CMD_COMMAND_RES_DTO_2 = b"\x83\x05"
CMD_COMMAND_STATUS_RES_DTO_2 = b"\x83\x06"
CMD_DEV_CONFIG_FETCH_RES_DTO_2 = b"\x83\x07"
CMD_DEV_CONFIG_PUT_RES_DTO_2 = b"\x83\x08"
CMD_GET_CONFIG_RES = b"\xdb\x08"
CMD_SET_CONFIG_RES = b"\xdb\x07"

CMD_CLOUD_INFO_DATA_RES_DTO = b"\x23\x01"
CMD_CLOUD_COMMAND_RES_DTO = b"\x23\x05"

CMD_ACTION_MICRO_DEFAULT = 0
CMD_ACTION_DTU_REBOOT = 1
CMD_ACTION_DTU_UPGRADE = 2
CMD_ACTION_MI_REBOOT = 3
CMD_ACTION_COLLECT_VERSION = 4
CMD_ACTION_ANTI_THEFT_SETTING = 5
CMD_ACTION_MI_START = 6
CMD_ACTION_MI_SHUTDOWN = 7
CMD_ACTION_LIMIT_POWER = 8
CMD_ACTION_REFLUX_CONTROL = 9
CMD_ACTION_CLEAN_GROUNDING_FAULT = 10
CMD_ACTION_CT_SET = 11
CMD_ACTION_MI_LOCK = 12
CMD_ACTION_MI_UNLOCK = 13
CMD_ACTION_SET_GRID_FILE = 14
CMD_ACTION_UPGRADE_MI = 15
CMD_ACTION_ID_NETWORKING = 16
CMD_ACTION_REFLUX_NETWORKING = 17
CMD_ACTION_STOP_CONTROLLER_CMD = 18
CMD_ACTION_SET_WIFI_PASS = 19
CMD_ACTION_SET_SVR_DNS_PORT = 20
CMD_ACTION_SET_GPRS_APN = 21
CMD_ACTION_ANTI_THEFT_CONTROL = 22
CMD_ACTION_PERFORMANCE_DATA_MODE = 33
CMD_ACTION_REPEATER_NETWORKING = 0
CMD_ACTION_DTU_DEFAULT = 0
CMD_ACTION_GATEWAY_DEFAULT = 0
CMD_ACTION_METER_REVERSE = 49
CMD_ACTION_ALARM_LIST = 50
CMD_ACTION_GW_REBOOT = 4096
CMD_ACTION_GW_RESET = 4097
CMD_ACTION_GW_STOP_RUN = 4098
CMD_ACTION_GW_COLLECT_REAL_DATA = 4099
CMD_ACTION_GW_COLLECT_VER = 4100
CMD_ACTION_GW_AUTO_NETWORKING = 4101
CMD_ACTION_GW_UPGRADE = 4102
CMD_ACTION_MICRO_MEMORY_SNAPSHOT = 53
CMD_ACTION_MICRO_DATA_WAVE = 54
CMD_ACTION_SET_485_PORT = 36
CMD_ACTION_THREE_BALANCE_SET = 37
CMD_ACTION_MI_GRID_PROTECT_SELF = 38
CMD_ACTION_SUN_SPEC_CONFIG = 39
CMD_ACTION_POWER_GENERATION_CORRECT = 40
CMD_ACTION_GRID_FILE_READ = 41
CMD_ACTION_CLEAN_WARN = 42
CMD_ACTION_DRM_SETTING = 43
CMD_ACTION_ES_CONFIG_MANAGER = 0
CMD_ACTION_ES_USER_SETTING = 0
CMD_ACTION_READ_MI_HU_WARN = 46
CMD_ACTION_LIMIT_POWER_PF = 47
CMD_ACTION_LIMIT_POWER_REACTIVE = 48
CMD_ACTION_INV_BOOT_UP = 8193
CMD_ACTION_INV_SHUTDOWN = 8194
CMD_ACTION_INV_REBOOT = 8195
CMD_ACTION_INV_RESET = 8196
CMD_ACTION_INV_CLEAN_WARN = 8197
CMD_ACTION_INV_CLEAN_HIS_DATA = 8198
CMD_ACTION_INV_UPLOAD_REAL_DATA = 8199
CMD_ACTION_INV_FIND_DEV = 8200
CMD_ACTION_INV_BATTERY_MODE_CONFIG = 0
CMD_ACTION_BMS_REBOOT = 8224
CMD_ACTION_BMS_URGENT_CHARGING = 8225
CMD_ACTION_BMS_BALANCE = 8208
CMD_ACTION_INV_UPGRADE = 4112
CMD_ACTION_BMS_UPGRADE = 4112


DEV_DTU = 1
DEV_REPEATER = 2
DEV_MICRO = 3
DEV_MODEL = 4
DEV_METER = 5
DEV_INV = 6
DEV_RSD = 7
DEV_OP = 8
DEV_GATEWAY = 9
DEV_BMS = 10

DTU_FIRMWARE_URL_00_01_11 = (
    "http://fwupdate.hoymiles.com/cfs/bin/2311/06/,1488725943932555264.bin"
)

MAX_POWER_LIMIT = 100
OFFSET = 28800
